/*
 * gs path to obj converter
 * 
 * reads path file and converts to obj file
 *
 * by eis_os (cim bytetransfer.de)
 * 
 * last update: 24.12.2011
 *
 */


#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "gs.h"
#include "gs_math.h"
#include "gs_filefunc.h"
#include "gs_path.h"

#define TOOLNAME "gs_path2obj " GS_TOOLS_VERSION 

// options
static int force_overwrite;

void usage(char *name) {
    printf("Usage: %s <options> <PATHS file>\n"
    " -f force overwrite\n", name);
}

// only interfaces gs_path.c
int main(int argc, char **argv)
{
    int i;
    char *path = NULL, *filename = NULL, *basefilename = NULL;
    struct path_data_ll *path_list;

    printf(TOOLNAME "\n");
    if(argc < 2) {
	usage(argv[0]);
	return -1;
    }
    /* if(argc == 3) {
	char *arg = argv[1];
	if(arg[0] == '-' && arg[1] == 'f')
	    force_overwrite = 1;
	argv++;
    } 
    
    filename = strrchr(argv[1], PATH_DELIMITER);
       
    if(filename) {
	*filename++ = '\0';
	path = argv[1];
	if(chdir(path) != 0)
	    die("chdir('%s') failed: %s\n", path, strerror(errno));
    } else {
	path = ".";
	filename = argv[1];
    }
    */

    for(i=1; i<argc; i++) {
        char *arg = argv[i];
        if(arg[0] == '-') {
            if (arg[1] == 'f') {
                force_overwrite = 1;
            } else {
                printf("Unknown option %s \n", argv[i]);
                return -1;
            }
	} else {
            filename = strrchr(argv[i], PATH_DELIMITER);
            if(filename) {
	        *filename++ = '\0';
                path = argv[i];
                if(chdir(path) != 0)
                   die("chdir('%s') failed: %s\n", path, strerror(errno));
            } else {
                path = ".";
                filename = argv[i];
            }
        }
    }
       
    if (!filename) {
        usage(argv[0]);
        return -1;
    }
    basefilename = filename_noext(filename);
    
    printf("working dir: %s\n", path);
    
    char *obj_filename = make_path(NULL, basefilename, "_paths.obj");
    
    if (!file_exists(filename)) {
          printf("reading: '%s' failed not found...\n", filename);
          return -1;
    }
    path_list = read_paths_file(filename);
    write_obj_path_file_combined(obj_filename, force_overwrite, path_list, TOOLNAME);
    return 0;
}